CREATE PROCEDURE   `um_star_update_all`(in starid int,in sys char(3),in cli char(3))
    COMMENT 'Version 5.2.12'
BEGIN
-- ---------------------------------------
-- recalculate all roles and make fill history tables 
-- starid id from um_starfile
-- sys system to update
-- cli client to update
-- ---------------------------------------

	    -- create a temp table to hold the values from um_role_auth
	    CREATE TEMPORARY TABLE link( rid INT , role int, step int, rname varchar(45));
	    
	    -- all values are convertet to range and compared
	    
	    -- find all object where high is not set
	    insert into link (rid,role,step) 
	        (select um_role_auth.id,um_role_auth.role_id,um_starfile_data.step 
	        FROM um_role_auth INNER JOIN um_starfile_data 
	        ON um_role_auth.object = um_starfile_data.object and um_role_auth.field=um_starfile_data.field and 
	        (REPLACE(um_role_auth.low, '*', '')<=REPLACE(um_starfile_data.value, '*', 'z'))  and 
	        (REPLACE(um_role_auth.low, '*', 'z')>=REPLACE(um_starfile_data.value, '*', '')) and 
	         um_role_auth.high ='' 
	        where um_starfile_data.um_star_id =starid);
	        
	    -- find all object where high is also set
	    insert into link (rid,role,step) 
	        (select um_role_auth.id,um_role_auth.role_id,um_starfile_data.step 
	        FROM um_role_auth INNER JOIN um_starfile_data 
	        ON um_role_auth.object = um_starfile_data.object and um_role_auth.field=um_starfile_data.field and 
	        (REPLACE(um_role_auth.low, '*', '')<=REPLACE(um_starfile_data.value, '*', 'z'))  and 
	        (REPLACE(um_role_auth.high, '*', 'z')>=REPLACE(um_starfile_data.value, '*', '')) and 
	         um_role_auth.high >'' 
	        where um_starfile_data.um_star_id =starid);
	    
	    -- clear the old roles
	    update um_role set um_role.star_category_step = 0 
	         WHERE `system` = sys AND client = cli;
	       
	   -- insert the new
	    update um_role 
	        inner join (select role, min(step) as minimum from link group by role) temp on id=temp.role 
	        set star_category_step=temp.minimum 
	        WHERE `system` = sys AND client = cli;

	    DROP TEMPORARY TABLE link;
	    
 
	    -- update history
	    insert into  um_dash_star_role_history 
            select * from
	        (select `system`,client, current_date, star_category_step,count(star_category_step) as step2 from um_role 
	        WHERE `system` = sys AND `client` = cli group by `system`,client, current_date,star_category_step ) as t2
	        ON DUPLICATE KEY UPDATE count =step2;


	    -- update the composite roles maybe it should be after role history
      update  um_role as a,
      (
       SELECT um_role.id,min(um_role_1.star_category_step) as step
		   FROM um_role_comp INNER JOIN um_role
			   ON um_role_comp.composite = um_role.id
			   INNER JOIN um_role um_role_1
				 ON um_role_comp.single = um_role_1.id
	     where um_role_1.star_category_step >0
		   group by um_role.id)as b
		   set a.star_category_step = b.step
		   where a.id = b.id;

	    -- update user star cat
	      insert into  um_dash_star_user
         select * from
	    (select  a.`system`,a.client,user_id,min(star_category_step) as step2 from um_user_role a
	    inner join um_role b on a.role_id = b.id  WHERE a.`system` = sys AND  a.`client` = cli group by user_id) as t2
	    ON DUPLICATE KEY UPDATE step = step2;
        
		insert into  um_dash_star_user
         select * from
	    (select  a.`system`,a.client,user_id,min(star_category_step) as step2 from um_user_role a
	    inner join um_role b on a.role_id = b.id  WHERE a.`system` = sys AND  a.`client` = cli and star_category_step >0 group by user_id) as t2
	    ON DUPLICATE KEY UPDATE step = step2;
	    
	

      -- update user star history
       insert into  um_dash_star_user_history 
       select * from
	       (select `system`,client, current_date,step,count(step) as count2 from um_dash_star_user
	        WHERE `system` = sys AND `client` = cli group by `system`,client,current_date,step ) as t2
	        ON DUPLICATE KEY UPDATE count = count2;


END